/*************************************************
* BeOS EntropySource Header File                 *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/base.h>

#ifndef BOTAN_EXT_ENTROPY_SRC_BEOS__
#define BOTAN_EXT_ENTROPY_SRC_BEOS__

namespace Botan {

class BeOS_EntropySource : public EntropySource
   {
   public:
      u32bit fast_poll(byte[], u32bit);
      u32bit slow_poll(byte[], u32bit);
      BeOS_EntropySource();
   private:
      u32bit copy_out(byte[], u32bit, u32bit);
      void add_bytes(const void*, u32bit);
      SecureBuffer<byte, 128> buffer;
      u32bit write_pos, read_pos;
   };

}

#endif
