/*************************************************
* File Tree Walking EntropySource Header File    *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/base.h>

#ifndef BOTAN_EXT_ENTROPY_SRC_FTW__
#define BOTAN_EXT_ENTROPY_SRC_FTW__

namespace Botan {

class FTW_EntropySource : public EntropySource
   {
   public:
      u32bit fast_poll(byte[], u32bit);
      u32bit slow_poll(byte[], u32bit);

      FTW_EntropySource(const std::string& = "/proc");
   private:
      void do_poll(u32bit);
      void gather_from_dir(const std::string&, u32bit);
      void gather_from_file(const std::string&);
      const std::string path;
      SecureBuffer<byte, 1024> buffer;
      u32bit position, files_read;
   };

}

#endif
