/*************************************************
* BigInt IA-32 Assembler Backend                 *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/mp_asm.h>

   .text

/*
   word bigint_add2_nc(word* const x, u32bit x_size,
                       const word* y, u32bit y_size)
*/
FUNCTION(bigint_add2_nc)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	xorl	%edi, %edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$12, %esp
	cmpl	20(%ebp), %edi
	je	.L02
        SET_ALIGN
.L01:
	movl	8(%ebp), %ecx
	xorl	%edx, %edx
	movl	16(%ebp), %ebx
	movl	(%ecx,%esi,4), %eax
	movl	(%ebx,%esi,4), %ecx
	xorl	%ebx, %ebx
	addl	%ecx, %eax
	movl	8(%ebp), %ecx
	adcl	%ebx, %edx
	xorl	%ebx, %ebx
	addl	%edi, %eax
	adcl	%ebx, %edx
	movl	%edx, %edi
	movl	%eax, (%ecx,%esi,4)
	incl	%esi
	cmpl	20(%ebp), %esi
	jne	.L01
.L02:
	xorl	%eax, %eax
	testl	%edi, %edi
	je	.L05
	movl	20(%ebp), %edx
	cmpl	12(%ebp), %edx
	je	.L04
        SET_ALIGN
.L03:
	movl	8(%ebp), %ebx
	movl	(%ebx,%edx,4), %eax
	incl	%eax
	movl	%eax, (%ebx,%edx,4)
	testl	%eax, %eax
	jne	.L06
	incl	%edx
	cmpl	12(%ebp), %edx
	jne	.L03
.L04:
	movl	$1, %eax
.L05:
	addl	$12, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L06:
	xorl	%eax, %eax
	jmp	.L05

/*
   void bigint_add2(word* const x, u32bit x_size,
                    const word* y, u32bit y_size)
*/
FUNCTION(bigint_add2)
	pushl	%ebp
	movl	%esp, %ebp
	subl	$24, %esp
	movl	%ebx, -8(%ebp)
	movl	16(%ebp), %eax
	movl	12(%ebp), %ebx
	movl	%esi, -4(%ebp)
	movl	8(%ebp), %esi
	movl	%eax, 8(%esp)
	movl	20(%ebp), %eax
	movl	%ebx, 4(%esp)
	movl	%esi, (%esp)
	movl	%eax, 12(%esp)
	call	bigint_add2_nc
	addl	%eax, (%esi,%ebx,4)
	movl	-8(%ebp), %ebx
	movl	-4(%ebp), %esi
	movl	%ebp, %esp
	popl	%ebp
	ret

/*
   void bigint_add3(word* const z,
                    const word* x, u32bit x_size,
                    const word* y, u32bit y_size)
*/
FUNCTION(bigint_add3)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$56, %esp
	movl	8(%ebp), %eax
	movl	12(%ebp), %edx
	movl	16(%ebp), %ecx
	movl	20(%ebp), %ebx
	movl	%eax, -20(%ebp)
	movl	24(%ebp), %esi
	movl	%edx, -24(%ebp)
	movl	%ecx, -28(%ebp)
	movl	%ebx, -32(%ebp)
        SET_ALIGN
.L22:
	cmpl	%esi, -28(%ebp)
	jae	.L21
	movl	-28(%ebp), %edx
	movl	%esi, -28(%ebp)
	movl	-24(%ebp), %eax
	movl	-32(%ebp), %ecx
	movl	%edx, %esi
	movl	%eax, -32(%ebp)
	movl	%ecx, -24(%ebp)
	jmp	.L22
.L21:
	movl	$0, -36(%ebp)
	xorl	%edi, %edi
	cmpl	%esi, %edi
	je	.L39
        SET_ALIGN
.L27:
	movl	-24(%ebp), %ebx
	xorl	%edx, %edx
	movl	(%ebx,%edi,4), %eax
	movl	-32(%ebp), %ebx
	movl	(%ebx,%edi,4), %ecx
	xorl	%ebx, %ebx
	addl	%ecx, %eax
	movl	-36(%ebp), %ecx
	adcl	%ebx, %edx
	xorl	%ebx, %ebx
	addl	%ecx, %eax
	movl	-20(%ebp), %ecx
	adcl	%ebx, %edx
	movl	%edx, -36(%ebp)
	movl	%eax, (%ecx,%edi,4)
	incl	%edi
	cmpl	%esi, %edi
	jne	.L27
.L39:
	cmpl	-28(%ebp), %esi
	movl	%esi, %edx
	je	.L29
	movl	-28(%ebp), %eax
	subl	%esi, %eax
	leal	0(,%eax,4), %ecx
        SET_ALIGN
.L37:
	movl	-36(%ebp), %eax
	testl	%eax, %eax
	je	.L41
	movl	-24(%ebp), %ebx
	movl	-20(%ebp), %eax
	movl	(%ebx,%edx,4), %ebx
	addl	%ebx, -36(%ebp)
	movl	-36(%ebp), %ebx
	movl	%ebx, (%eax,%edx,4)
	movl	-24(%ebp), %eax
	cmpl	$-1, (%eax,%edx,4)
	sete	%al
	incl	%edx
	subl	$4, %ecx
	cmpl	-28(%ebp), %edx
	movzbl	%al, %eax
	movl	%eax, -36(%ebp)
	jne	.L37
.L29:
	movl	-36(%ebp), %ebx
	movl	-28(%ebp), %edx
	movl	-20(%ebp), %ecx
	movl	%ebx, (%ecx,%edx,4)
	addl	$56, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L41:
	leal	0(,%edx,4), %eax
	movl	-20(%ebp), %ebx
	movl	-24(%ebp), %edx
	cmpl	$3, %ecx
	leal	(%ebx,%eax), %edi
	leal	(%edx,%eax), %esi
	movl	%ecx, %edx
	jbe	.L33
	testl	$4, %edi
	je	.L34
	movl	(%esi), %eax
	leal	-4(%ecx), %edx
	addl	$4, %esi
	movl	%eax, (%edi)
	addl	$4, %edi
.L34:
	cld
	movl	%edx, %ecx
	shrl	$2, %ecx
	rep
	movsl
.L33:
	testl	$2, %edx
	je	.L35
	movzwl	(%esi), %eax
	addl	$2, %esi
	movw	%ax, (%edi)
	addl	$2, %edi
.L35:
	andl	$1, %edx
	je	.L29
	movzbl	(%esi), %eax
	movb	%al, (%edi)
	jmp	.L29

/*
   void bigint_sub2(word* const x, u32bit x_size,
                    const word* y, u32bit y_size)
*/
	.section	.rodata
	.align 8
	.type	_ZZ11bigint_sub2E8MP_RADIX,@object
	.size	_ZZ11bigint_sub2E8MP_RADIX,8
_ZZ11bigint_sub2E8MP_RADIX:
	.quad	0x100000000
	.text

FUNCTION(bigint_sub2)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	xorl	%edi, %edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$12, %esp
	cmpl	20(%ebp), %edi
	je	.L59
        SET_ALIGN
.L49:
	movl	8(%ebp), %ecx
	xorl	%edx, %edx
	movl	16(%ebp), %ebx
	movl	(%ecx,%esi,4), %eax
	movl	(%ebx,%esi,4), %ecx
	xorl	%ebx, %ebx
	subl	%ecx, %eax
	sbbl	%ebx, %edx
	xorl	%ebx, %ebx
	subl	%edi, %eax
	sbbl	%ebx, %edx
	addl	$0, %eax
	adcl	$1, %edx
	testl	%edx, %edx
	sete	%cl
	movzbl	%cl, %edi
	movl	8(%ebp), %ecx
	movl	%eax, (%ecx,%esi,4)
	incl	%esi
	cmpl	20(%ebp), %esi
	jne	.L49
.L59:
	movl	20(%ebp), %esi
	cmpl	12(%ebp), %esi
	je	.L42
        SET_ALIGN
.L57:
	testl	%edi, %edi
	je	.L42
	movl	8(%ebp), %ebx
	xorl	%edx, %edx
	movl	(%ebx,%esi,4), %eax
	xorl	%ebx, %ebx
	subl	%edi, %eax
	sbbl	%ebx, %edx
	addl	$0, %eax
	adcl	$1, %edx
	testl	%edx, %edx
	sete	%cl
	movzbl	%cl, %edi
	movl	8(%ebp), %ecx
	movl	%eax, (%ecx,%esi,4)
	incl	%esi
	cmpl	12(%ebp), %esi
	jne	.L57
.L42:
	addl	$12, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret

/*
   void bigint_sub3(word* const z,
                    const word* x, u32bit x_size,
                    const word* y, u32bit y_size)
*/
	.section	.rodata
	.align 8
	.type	_ZZ11bigint_sub3E8MP_RADIX,@object
	.size	_ZZ11bigint_sub3E8MP_RADIX,8
_ZZ11bigint_sub3E8MP_RADIX:
	.quad	0x100000000
	.text
FUNCTION(bigint_sub3)
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	xorl	%edi, %edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$20, %esp
	cmpl	24(%ebp), %edi
	je	.L82
        SET_ALIGN
.L68:
	movl	12(%ebp), %ecx
	xorl	%edx, %edx
	movl	20(%ebp), %ebx
	movl	(%ecx,%esi,4), %eax
	movl	(%ebx,%esi,4), %ecx
	xorl	%ebx, %ebx
	subl	%ecx, %eax
	sbbl	%ebx, %edx
	xorl	%ebx, %ebx
	subl	%edi, %eax
	sbbl	%ebx, %edx
	addl	$0, %eax
	adcl	$1, %edx
	testl	%edx, %edx
	sete	%cl
	movzbl	%cl, %edi
	movl	8(%ebp), %ecx
	movl	%eax, (%ecx,%esi,4)
	incl	%esi
	cmpl	24(%ebp), %esi
	jne	.L68
.L82:
	movl	24(%ebp), %esi
	cmpl	16(%ebp), %esi
	je	.L67
	movl	16(%ebp), %eax
	subl	%esi, %eax
	sall	$2, %eax
	movl	%eax, -20(%ebp)
        SET_ALIGN
.L80:
	testl	%edi, %edi
	je	.L84
	movl	12(%ebp), %ecx
	xorl	%ebx, %ebx
	xorl	%edx, %edx
	movl	(%ecx,%esi,4), %eax
	subl	%edi, %eax
	sbbl	%ebx, %edx
	movl	8(%ebp), %ebx
	addl	$0, %eax
	adcl	$1, %edx
	testl	%edx, %edx
	sete	%cl
	movl	%eax, (%ebx,%esi,4)
	incl	%esi
	subl	$4, -20(%ebp)
	movzbl	%cl, %edi
	cmpl	16(%ebp), %esi
	jne	.L80
.L67:
	addl	$20, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
.L84:
	movl	12(%ebp), %edx
	leal	0(,%esi,4), %eax
	movl	8(%ebp), %ebx
	leal	(%edx,%eax), %esi
	movl	-20(%ebp), %edx
	leal	(%ebx,%eax), %edi
	cmpl	$3, %edx
	jbe	.L74
	testl	$4, %edi
	je	.L75
	movl	(%esi), %eax
	addl	$4, %esi
	movl	%eax, (%edi)
	addl	$4, %edi
	movl	-20(%ebp), %edx
	subl	$4, %edx
.L75:
	cld
	movl	%edx, %ecx
	shrl	$2, %ecx
	rep
	movsl
.L74:
	testl	$2, %edx
	je	.L76
	movzwl	(%esi), %eax
	addl	$2, %esi
	movw	%ax, (%edi)
	addl	$2, %edi
.L76:
	andl	$1, %edx
	je	.L67
	movzbl	(%esi), %eax
	movb	%al, (%edi)
	jmp	.L67

/*
   void bigint_linmul2(word* const x, u32bit x_size, word y)
*/
FUNCTION(bigint_linmul2)
	pushl	%ebp
	movl	%esp, %ebp
	xorl	%ecx, %ecx
	pushl	%edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$12, %esp
	movl	8(%ebp), %edi
	cmpl	12(%ebp), %ecx
	je	.L92
        SET_ALIGN
.L90:
	movl	16(%ebp), %eax
	xorl	%ebx, %ebx
	mull	(%edi,%esi,4)
	movl	%eax, -24(%ebp)
	addl	%ecx, -24(%ebp)
	movl	%edx, -20(%ebp)
	movl	-24(%ebp), %edx
	adcl	%ebx, -20(%ebp)
	movl	%edx, (%edi,%esi,4)
	incl	%esi
	movl	-20(%ebp), %edx
	cmpl	12(%ebp), %esi
	movl	%edx, %ecx
	jne	.L90
.L92:
	movl	12(%ebp), %edx
	movl	%ecx, (%edi,%edx,4)
	addl	$12, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret

/*
   void bigint_linmul3(word* const z,
                       const word* x, u32bit x_size, word y)
*/
FUNCTION(bigint_linmul3)
	pushl	%ebp
	movl	%esp, %ebp
	xorl	%ecx, %ecx
	pushl	%edi
	pushl	%esi
	xorl	%esi, %esi
	pushl	%ebx
	subl	$12, %esp
	movl	16(%ebp), %edi
	cmpl	%edi, %ecx
	je	.L61
        SET_ALIGN
.L60:
	movl	12(%ebp), %ebx
	movl	20(%ebp), %eax
	mull	(%ebx,%esi,4)
	xorl	%ebx, %ebx
	movl	%eax, -24(%ebp)
	movl	8(%ebp), %eax
	addl	%ecx, -24(%ebp)
	movl	%edx, -20(%ebp)
	movl	-24(%ebp), %edx
	adcl	%ebx, -20(%ebp)
	movl	%edx, (%eax,%esi,4)
	incl	%esi
	movl	-20(%ebp), %edx
	cmpl	%edi, %esi
	movl	%edx, %ecx
	jne	.L60
.L61:
	movl	8(%ebp), %edx
	movl	%ecx, (%edx,%edi,4)
	addl	$12, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
