/*************************************************
* Aliases List Source File                       *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/look_add.h>

namespace Botan {

/*************************************************
* Load the algorithms list                       *
*************************************************/
void setup_aliases()
   {
   add_alias("AES", "Rijndael");
   add_alias("CAST5", "CAST-128");
   add_alias("SHA1", "SHA-160");
   add_alias("SHA-1", "SHA-160");
   add_alias("SEAL", "SEAL-3.0-BE");
   add_alias("3-Way", "ThreeWay");
   add_alias("SHARK", "SHARK-E");

   add_alias("1.2.840.113549.1.5.1",  "PBE-PKCS5v15(MD2,DES/CBC)");
   add_alias("1.2.840.113549.1.5.4",  "PBE-PKCS5v15(MD2,RC2/CBC)");
   add_alias("1.2.840.113549.1.5.3",  "PBE-PKCS5v15(MD5,DES/CBC)");
   add_alias("1.2.840.113549.1.5.6",  "PBE-PKCS5v15(MD5,RC2/CBC)");
   add_alias("1.2.840.113549.1.5.10", "PBE-PKCS5v15(SHA-1,DES/CBC)");
   add_alias("1.2.840.113549.1.5.11", "PBE-PKCS5v15(SHA-1,RC2/CBC)");
   add_alias("1.2.840.113549.1.5.13", "PBE-PKCS5v20");

   add_alias("EMSA-PKCS1-v1_5", "EMSA3");
   add_alias("EME-PKCS1-v1_5", "PKCS1v15");
   add_alias("OAEP-MGF1", "EME1");
   add_alias("EME-OAEP", "EME1");
   add_alias("PSS-MGF1", "EMSA4");
   add_alias("EMSA-PSS", "EMSA4");

   add_alias("TLS.Digest.0", "Parallel(MD5,SHA-1)");

   add_alias("OpenPGP.Cipher.1", "IDEA");
   add_alias("OpenPGP.Cipher.2", "TripleDES");
   add_alias("OpenPGP.Cipher.3", "CAST-128");
   add_alias("OpenPGP.Cipher.4", "Blowfish");
   add_alias("OpenPGP.Cipher.5", "SAFER-SK(13)");
   add_alias("OpenPGP.Cipher.7", "AES");
   add_alias("OpenPGP.Cipher.8", "AES");
   add_alias("OpenPGP.Cipher.9", "AES");
   add_alias("OpenPGP.Cipher.10", "Twofish");

   add_alias("OpenPGP.Digest.1", "MD5");
   add_alias("OpenPGP.Digest.2", "SHA-1");
   add_alias("OpenPGP.Digest.3", "RIPEMD-160");
   add_alias("OpenPGP.Digest.5", "MD2");
   add_alias("OpenPGP.Digest.6", "Tiger(24,3)");
   add_alias("OpenPGP.Digest.7", "HAVAL(20,5)");
   }

}
