/*************************************************
* BigInt Constants Source File                   *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/bigint.h>
#include <botan/numthry.h>
#include <botan/rng.h>

namespace Botan {

namespace {

BigInt* zero_integer;
BigInt* one_integer;

}

/*************************************************
* External shutdown function                     *
*************************************************/
extern void destroy_dl_groups();

/*************************************************
* Create the global constant BigInts             *
*************************************************/
void create_global_bigints()
   {
   zero_integer = new BigInt(0);
   one_integer  = new BigInt(1);
   }

/*************************************************
* Delete the global constant BigInts             *
*************************************************/
void delete_global_bigints()
   {
   destroy_dl_groups();
   delete zero_integer;
   delete one_integer;
   }

/*************************************************
* Return zero                                    *
*************************************************/
const BigInt& BigInt::zero()
   {
   return (*zero_integer);
   }

/*************************************************
* Return one                                     *
*************************************************/
const BigInt& BigInt::one()
   {
   return (*one_integer);
   }

}
